#
# spec file for package i3lock
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
# Copyright (c) 2014 B1 Systems GmbH, Vohburg, Germany.
# Copyright (c) 2012 Pascal Bleser <pascal.bleser@opensuse.org>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


# Please submit bugfixes or comments via http://bugs.opensuse.org/

Name:           i3lock
Version:        2.8
Release:        1.1
Summary:        Screen Locker for the i3 Window Manager
License:        BSD-3-Clause
Group:          System/GUI/Other
Source:         http://i3wm.org/i3lock/i3lock-%{version}.tar.bz2
Source1:        i3lock.pam
# borrowed from gnome-icon-theme
Source2:        i3lock-icon.png
Source3:        xlock.sh
# PATCH-FEATURE-OPENSUSE i3lock-2.5-use-unix2_chkpwd.diff -- seife+obs@b1-systems.com
Patch1:         i3lock-2.5-use-unix2_chkpwd.diff
Url:            http://i3wm.org/i3lock/
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  cairo-devel
BuildRequires:  gcc
BuildRequires:  glib2-devel
BuildRequires:  glibc-devel
BuildRequires:  libev-devel
%if 0%{?suse_version} > 1310
# /usr/lib64/libEGL.so.1 now requires libudev.so.1, might be a packaging error
BuildRequires:  libudev1
%endif
BuildRequires:  make
BuildRequires:  pam-devel
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(cairo)
BuildRequires:  pkgconfig(xcb-atom)
BuildRequires:  pkgconfig(xkbcommon-x11)
Requires:       pam-modules
BuildRequires:  pam-modules
BuildRequires:  pkgconfig(xcb-image)
BuildRequires:  pkgconfig(xcb-keysyms)
BuildRequires:  pkgconfig(xkbcommon) >= 0.5.0

%description
i3lock is a simple screen locker like slock. After starting it, you will see a
white screen (you can configure the color/an image). You can return to your
screen by entering your password.

%package xlock-compat
Summary:        Xlock-compatibility script which calls i3lock
Group:          System/GUI/Other
Requires:       ImageMagick
Requires:       xdpyinfo
Conflicts:      xlockmore

%description xlock-compat
This package provides a script /usr/bin/xlock which calls i3lock to lock your screen.
This is handy for hard-coded screen-saver invocations e.g. in XFCE4, so you can use
i3lock instead of xlock with them.

%prep
%setup -q
%patch1 -p1

%build
export CFLAGS="%{optflags}"
make %{?_smp_mflags} \
    USE_UNIX2_CHKPWD=1 \
    PREFIX="%{_prefix}" \
    SYSCONFDIR="%{_sysconfdir}"

%install
export CFLAGS="%{optflags}"
make \
    USE_UNIX2_CHKPWD=1 \
    PREFIX="%{_prefix}" \
    SYSCONFDIR="%{_sysconfdir}" \
    DESTDIR="%{buildroot}" \
    install

rm "%{buildroot}%{_sysconfdir}/pam.d/i3lock"
install -m0644 "%{SOURCE1}" "%{buildroot}%{_sysconfdir}/pam.d/%{name}"

install -D -m0644 i3lock.1 "%{buildroot}%{_mandir}/man1/i3lock.1"

install -D -m0644 %{SOURCE2} %{buildroot}/usr/share/i3lock-xlock-compat/i3lock-icon.png
install -m0755 %{SOURCE3} %{buildroot}/%{_bindir}/xlock

%files xlock-compat
%defattr(-,root,root)
%{_bindir}/xlock
%{_datadir}/i3lock-xlock-compat

%files
%defattr(-,root,root)
%doc CHANGELOG LICENSE README.md
%config(noreplace) %{_sysconfdir}/pam.d/%{name}
%{_bindir}/i3lock
%doc %{_mandir}/man1/i3lock.1*

%changelog
* Sun Dec 18 2016 mimi.vx@gmail.com
- update to 2.8
- refresh i3lock-2.5-use-unix2_chkpwd.diff
  * Remove DPMS support in favor of a wrapper script and xset
  * Indicate that the --inactivity-timeout option takes an argument
  * fix pam_securetty: set PAM_TTY to getenv("DISPLAY")
  * Eat XKB_KEY_Delete and XKB_KEY_KP_Delete
  * Show unlock indicator if password was entered during PAM verification
  * Allow CTRL+J as enter and CTRL+H as backspace
  * Flush xcb connection after opening fullscreen window
  * Add support for `xss-lock --transfer-sleep-lock'
* Tue Apr 26 2016 mimi.vx@gmail.com
- update to 2.7
- refresh i3lock-2.5-use-unix2_chkpwd.diff
  * Die when the X11 connection breaks during runtime
  * Implement logging the number of failed attempts
  * Ignore password validation is pam is in wrong state
  * Get current user with getpwuid() instead of using $ENV{USER}
  * Add support for Compose and dead-keys with libxkbcommon.
  Requires libxkbcommon ≥ 0.5.0
  * Format the source using clang-format.
  * Refresh pam credentials on successful authentication (for Kerberos and the
  like)
  * List pressed modifiers on failed authentication
  * Only redraw the screen if the unlock indicator is actually used
  * Make pkg-config configurable for cross-compilation
* Sat May  9 2015 mpluskal@suse.com
- Add missing dependency on xdpyinfo (boo#930330)
* Mon Jan 19 2015 p.drouand@gmail.com
- Update to version 2.6
  * NEW DEPENDENCY: use libxkbcommon-x11 instead of libX11
    This helps us get rid of all code that directly uses libX11
  * Use cairo_status_to_string for descriptive errors.
  * Add `-e` option to not validate empty password.
  * Bugfix: update the initial keyboard modifier state (Thanks lee, Ran)
  * Re-raise i3lock when obscured in a separate process
  * Turn on the screen on successful authentication
  * Delay to turn off the screen after wrong passwd
  * Discard half-entered passwd after some inactivity
  * Ignore empty passwd after repeated Enter keypress
  * Scale the unlock indicator (for retina displays)
- Replace xorg-x11-devel with pkgconfig(xkbcommon-x11); follow
  upstream changes
- Add pkgconfig(cairo) and pkgconfig(xcb-atom) requirements; new
  upstream dependencies
- Remove redundant %%clean section
* Thu Mar 20 2014 seife+obs@b1-systems.com
- add i3lock-xlock-compat package which provides /usr/bin/xlock
  for drop-in replacement in e.g. xflock4
* Mon Feb 17 2014 seife+obs@b1-systems.com
- readd the pam config file, which is still needed by unix2_chkpwd
  (I should read the man page more thoroughly next time)
* Sat Feb 15 2014 seife+obs@b1-systems.com
- add patch to use unix2_chkpwd instead of pam directly (which
  would need to make i3lock sgid shadow to work for non-root)
  * i3lock-2.5-use-unix2_chkpwd.diff
* Sat Feb 15 2014 seife+obs@b1-systems.com
- update to version 2.5:
  * NEW DEPENDENCY: Use libxkbcommon for input handling
    This makes input handling much better for many edge cases.
  * Bugfix: fix argument parsing on ARM (s/char/int/)
  * Bugfix: free(reply) to avoid memory leak
  * Bugfix: Use ev_loop_fork after fork, fixes forking on kqueue based OSes
  * Bugfix: Fix centering the indicator in the no-xinerama case
  * promote the "could not load image" message from debug to normal
  * s/pam_message/pam_response/ (Thanks Tucos)
  * remove support for NOLIBCAIRO, cairo-xcb is widespread by now
  * Allow XKB_KEY_XF86ScreenSaver as synonym for enter
    This keysym is generated on convertible tablets by pressing a hardware
    lock/unlock button.
  * Allow passwordless PAM conversations (e.g. fingerprint)
  * Add ctrl+u password reset
  * Set window name to i3lock
* Thu Mar  7 2013 toganm@opensuse.org
- Add xcb-keysyms  xcb-image to BuildRequires
- cleanup spec
* Wed Nov 14 2012 pascal.bleser@opensuse.org
- initial version (2.4.1)
